{************************************************}
{                                                }
{ E! for Windows                                 }
{ (c) - Patrick Philippot - 1992,93              }
{ EWAPI DLL import unit                          }
{ version 1.1                                    }
{                                                }
{************************************************}
{$IFDEF DEBUG}
{$A-,G+,B-,D+,F+,I-,N-,R+,S-,V-,L+}
{$ELSE}
{$A-,G+,B-,D-,F+,I-,N-,R-,S-,V-,L-}
{$ENDIF}

unit EWAPIImp;

INTERFACE

uses WinTypes, EWTypes;

{$I ewuser.inc}

{///////////////////////////// EW Primer access ///////////////////////////}

function EWAddTab(col : integer; fAdd : word) : integer;
function EWAlternateHelp(col, row : integer) : integer;
function EWBeginLine(fSkipToPrev : word) : integer;
function EWBlockShift : integer;
function EWBlockSort(fAscend : word) : integer;
function EWCase(fUpper : word) : integer;
function EWCheckBrace(col, row : integer) : integer;
function EWClearLine(row : integer) : integer;
function EWExecCompileCommand(commandindex : word) : integer;
function EWDeleteChar : integer;
function EWDeleteCurLine : integer;
function EWDeleteEOL : integer;
function EWDeleteLeft(fDeleteCurrent : word) : integer;
function EWDeleteLines(start, num : integer) : integer;
function EWDeleteSelection  : integer;
function EWDeleteWord : integer;
function EWEndLine(fSkipToNext, fStrip : word) : integer;
function EWFillBlock(ch : char) : integer;
function EWGetFile(Name : PChar; row : integer) : integer;
function EWGotoBookmark(index : word) : integer;
function EWGotoNextParagraph : integer;
function EWGotoNextTab : integer;
function EWGotoPrevTab : integer;
function EWGotoPrevParagraph : integer;
function EWGotoCompileError(fNext : word) : integer;
function EWGotoLine(row : integer) : integer;
function EWGotoXY(col, row : integer) : integer;
function EWGotoSelection(fBegin : word) : integer;
function EWInsertBrace(col, row : integer) : integer;
function EWInsertLines(start, num : integer) : integer;
function EWInsertMacroText(col, row : integer; macrotype : word) : integer;
function EWJoinLine(row : integer) : integer;
function EWLoadUserFile(col, row : integer) : integer;
function EWNextCol : integer;
function EWNextLine : integer;
function EWNextWord(fNext : word) : integer;
function EWTopOfPage(fTop : word) : integer;
function EWHorzPageScroll(fLeft : word) : integer;
function EWVerPageScroll(fUp : word) : integer;
function EWPrevCol : integer;
function EWPrevLine : integer;
function EWPaste(fInsert : word) : integer;
function EWReflow(row : integer) : integer;
function EWRefresh(fAsk : word) : integer;
function EWRemoveBookmark(index : word) : integer;
function EWSaveFile(Name : PChar) : integer;
function EWSelectAll : integer;
function EWSetBookmark(col, row : integer) : integer;
function EWSetClipboard(fAppend : word) : integer;
function EWPositionCurLine(position : word) : integer;
function EWShiftTextRight(col, row, count : integer) : integer;
function EWSplitLine(col, row : integer) : integer;
function EWStepScroll(dX, dY : integer) : integer;
function EWSumBlock : integer;
function EWStripFlow : integer;
function EWTopOfText(fTop : word) : integer;
function EWTextToCurSor : integer;
function EWToggleInsert : integer;
function EWUpcaseFirst(col, row : integer) : integer;
function EWWriteBlock(startrow, endrow, startcol, endcol : integer;
                      Name      : PChar;
                      mode,
                      fBlock,
                      fCompress : word) : integer;

{//////////////////////// Service Routines ////////////////////////////////}

function  EWAddMenuEntry(Command, Title : PChar; CommandId : word; AssignMode : word; RoutineId : word) : longint;
function  EWBeginSelection(SelType : word; col, row : integer) : integer;
function  EWCallUserExt(ExtName : PChar) : integer;
function  EWEditFile(Name : PChar) : longint;
function  EWEndSelection : integer;
procedure EWEnumClones(EditorId : longint; CloneEnumProc : TEnumClonesProc);
procedure EWEnumEditors(EdEnumProc : TEnumEditorsProc);
function  EWFind(MatchLen : PWord) : longint;
function  EWFindRegular(src, dest : PChar; MatchLen : PWord) : word;
function  EWGetCaretPos : longint;
function  EWGetCloneNum : word;
function  EWGetCurWord : longint;
function  EWGetCurrentEditor : longint;
function  EWGetFileName(EditorId : longint) : PChar;
function  EWGetGlobalFlag(FlagId : word) : integer;
function  EWGetInsertState : word;
function  EWGetLineAt(index : integer) : PChar;
function  EWGetLineCount : integer;
function  EWGetLocalFlag(FlagId : word) : integer;
function  EWGetSearchFlag(FlagId : word) : integer;
procedure EWGetSelection(Selection : PSelStruct);
function  EWGetTextPos : longint;
function  EWGetVersion : word;
function  EWGetWindowHandle : word;
function  EWGetTextWindowHandle : word;
function  EWIsRegistered :word;
procedure EWRemoveHook(hFlag : word; HookAddress : pointer);
function  EWRemoveMenuEntry(Id : longint) : longint;
function  EWRepeatFind(MatchLen : PWord) : longint;
procedure EWSetCCHandle(H : HWnd);
function  EWSetCurrentEditor(EditorId : longint) : longint;
procedure EWSetEditorId(EditorId : longint);
procedure EWSetFindPattern(pattern : PChar);
function  EWSetGlobalFlag(FlagId, value : word) : integer;
procedure EWSetHook(hFlag : word; HookAddress : pointer);
function  EWSetLineAt(P : PChar; index : integer) : integer;
function  EWSetLocalFlag(FlagId, value : word) : integer;
procedure EWSetModified;
function  EWSetSearchFlag(FlagId, value : word) : integer;
procedure EWSetWindowHandle(H : HWnd);
function  EWStopSelection(col, row : integer) : integer;
function  EWUpdateSelection(col, row : integer) : integer;
procedure EWWriteMessage(message : PChar);
function  EWGetInstance : word;

IMPLEMENTATION

function EWAddTab;                     external 'ewapi' index  1;
function EWBeginLine;                  external 'ewapi' index  2;
function EWBlockShift;                 external 'ewapi' index  3;
function EWBlockSort;                  external 'ewapi' index  4;
function EWCase;                       external 'ewapi' index  5;
function EWCheckBrace;                 external 'ewapi' index  6;
function EWClearLine;                  external 'ewapi' index  7;
function EWExecCompileCommand;         external 'ewapi' index  8;
function EWDeleteChar;                 external 'ewapi' index  9;
function EWDeleteCurLine;              external 'ewapi' index 10;
function EWDeleteEOL;                  external 'ewapi' index 11;
function EWDeleteLeft;                 external 'ewapi' index 12;
function EWDeleteLines;                external 'ewapi' index 13;
function EWDeleteSelection;            external 'ewapi' index 14;
function EWDeleteWord;                 external 'ewapi' index 15;
function EWEndLine;                    external 'ewapi' index 16;
function EWFillBlock;                  external 'ewapi' index 17;
function EWGetFile;                    external 'ewapi' index 18;
function EWGotoBookmark;               external 'ewapi' index 19;
function EWGotoNextParagraph;          external 'ewapi' index 20;
function EWGotoNextTab;                external 'ewapi' index 21;
function EWGotoPrevTab;                external 'ewapi' index 22;
function EWGotoPrevParagraph;          external 'ewapi' index 23;
function EWGotoCompileError;           external 'ewapi' index 24;
function EWGotoLine;                   external 'ewapi' index 25;
function EWGotoXY;                     external 'ewapi' index 26;
function EWGotoSelection;              external 'ewapi' index 27;
function EWInsertBrace;                external 'ewapi' index 28;
function EWInsertLines;                external 'ewapi' index 29;
function EWInsertMacroText;            external 'ewapi' index 30;
function EWJoinLine;                   external 'ewapi' index 31;
function EWLoadUserFile;               external 'ewapi' index 32;
function EWNextCol;                    external 'ewapi' index 33;
function EWNextLine;                   external 'ewapi' index 34;
function EWNextWord;                   external 'ewapi' index 35;
function EWTopOfPage;                  external 'ewapi' index 36;
function EWHorzPageScroll;             external 'ewapi' index 37;
function EWVerPageScroll;              external 'ewapi' index 38;
function EWPrevCol;                    external 'ewapi' index 39;
function EWPrevLine;                   external 'ewapi' index 40;
function EWPaste;                      external 'ewapi' index 41;
function EWReflow;                     external 'ewapi' index 42;
function EWRefresh;                    external 'ewapi' index 43;
function EWRemoveBookmark;             external 'ewapi' index 44;
function EWSaveFile;                   external 'ewapi' index 45;
function EWSelectAll;                  external 'ewapi' index 46;
function EWSetBookmark;                external 'ewapi' index 47;
function EWSetClipboard;               external 'ewapi' index 48;
function EWPositionCurLine;            external 'ewapi' index 49;
function EWShiftTextRight;             external 'ewapi' index 50;
function EWSplitLine;                  external 'ewapi' index 51;
function EWStepScroll;                 external 'ewapi' index 52;
function EWSumBlock;                   external 'ewapi' index 53;
function EWStripFlow;                  external 'ewapi' index 54;
function EWTopOfText;                  external 'ewapi' index 55;
function EWTextToCurSor;               external 'ewapi' index 56;
function EWToggleInsert;               external 'ewapi' index 57;
function EWUpcaseFirst;                external 'ewapi' index 58;
function EWWriteBlock;                 external 'ewapi' index 59;
function EWAlternateHelp;              external 'ewapi' index 60;
{///////////////////////////////////////////////////////////////}
function  EWAddMenuEntry;              external 'ewapi' index 61;
function  EWBeginSelection;            external 'ewapi' index 62;
function  EWCallUserExt;               external 'ewapi' index 63;
function  EWEditFile;                  external 'ewapi' index 64;
function  EWEndSelection;              external 'ewapi' index 65;
procedure EWEnumClones;                external 'ewapi' index 66;
procedure EWEnumEditors;               external 'ewapi' index 67;
function  EWFind;                      external 'ewapi' index 68;
function  EWFindRegular;               external 'ewapi' index 69;
function  EWGetCaretPos;               external 'ewapi' index 70;
function  EWGetCloneNum;               external 'ewapi' index 71;
function  EWGetCurWord;                external 'ewapi' index 72;
function  EWGetCurrentEditor;          external 'ewapi' index 73;
function  EWGetFileName;               external 'ewapi' index 74;
function  EWGetGlobalFlag;             external 'ewapi' index 75;
function  EWGetInsertState;            external 'ewapi' index 76;
function  EWGetLineAt;                 external 'ewapi' index 77;
function  EWGetLineCount;              external 'ewapi' index 78;
function  EWGetLocalFlag;              external 'ewapi' index 79;
function  EWGetSearchFlag;             external 'ewapi' index 80;
procedure EWGetSelection;              external 'ewapi' index 81;
function  EWGetTextPos;                external 'ewapi' index 82;
function  EWGetVersion;                external 'ewapi' index 83;
function  EWGetWindowHandle;           external 'ewapi' index 84;
procedure EWRemoveHook;                external 'ewapi' index 86;
function  EWRemoveMenuEntry;           external 'ewapi' index 87;
function  EWRepeatFind;                external 'ewapi' index 88;
function  EWSetCurrentEditor;          external 'ewapi' index 90;
procedure EWSetFindPattern;            external 'ewapi' index 92;
function  EWSetGlobalFlag;             external 'ewapi' index 93;
procedure EWSetHook;                   external 'ewapi' index 94;
function  EWSetLineAt;                 external 'ewapi' index 95;
function  EWSetLocalFlag;              external 'ewapi' index 96;
function  EWSetSearchFlag;             external 'ewapi' index 97;
function  EWStopSelection;             external 'ewapi' index 99;
function  EWUpdateSelection;           external 'ewapi' index 100;
procedure EWWriteMessage;              external 'ewapi' index 101;
function  EWGetTextWindowHandle;       external 'ewapi' index 102;
procedure EWSetModified;               external 'ewapi' index 103;
function  EWGetInstance;               external 'ewapi' index 104;

end.
